package guest;

import java.io.Serializable;
import java.sql.Date;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Basic;

@Entity
public class Guest implements Serializable {
    private static final long serialVersionUID = 1L;

    // Persistent Fields:
    @Id @GeneratedValue
    Long id;
	
	@Basic
    private String name;
	
	@Basic
    private Date signingDate;

    // Constructors:
    public Guest() {
    }

    public Guest(String name) {
        this.name = name;
        this.signingDate = new Date(System.currentTimeMillis());
    }

    // String Representation:
    @Override
    public String toString() {
        return " " + this.getId() + ":" + this.getName() + ":" + signingDate ;
    }
	
	public Long getId() {
		return id;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName( String name ) {
		this.name = name;
	}
	
	public int hashCode() {
		return this.getName() == null ? 0 : this.getName().hashCode();
		// return id == null ? 0 : id.hashCode();
	}
	
	public boolean equals(Object obj) {
		if ( obj == this ) return true;
		if ( obj == null ) return false;
		boolean eq = false;
		if ( obj instanceof Guest ) {
			final Guest other = Guest.class.cast( obj );
			eq = other.getName() != null && other.getName().equalsIgnoreCase( this.getName() );
		}
		return eq;
	}
}